datablock AudioProfile(FuelExplosionSound)
{
filename = "~/data/sound/weapons/fuel_explosion.ogg";
description = AudioDefault3d;
preload = true;
};

datablock ParticleData(FuelExplosionSmoke)
{
   textureName          = "~/data/shapes/particles/smoke";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.05;
   constantAcceleration = -0.30;
   lifetimeMS           = 2200;
   lifetimeVarianceMS   = 300;
   useInvAlpha =  true;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;
   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.7 0.7 0.7 0.9";
   colors[2]     = "0.9 0.9 0.9 0.8";
   sizes[0]      = 4.0;
   sizes[1]      = 2.5;
   sizes[2]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(FuelExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 2;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 250;
   particles = "FuelExplosionSmoke";
};

datablock ParticleData(FuelExplosionFire)
{
   textureName          = "~/data/shapes/splody/debris.dts";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.1;
   constantAcceleration = 0.0;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 200;
   useInvAlpha =  false;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;
   colors[0]     = "0.9 0.9 0.9 0.9";
   colors[1]     = "0.8 0.8 0.0 0.7";
   colors[2]     = "0.7 0.3 0.0 0.9";
   sizes[0]      = 0.7;
   sizes[1]      = 0.3;
   sizes[2]      = 0.2;
   times[0]      = 0.0;
   times[1]      = 0.3;
   times[2]      = 0.6;
};

datablock ParticleEmitterData(FuelExplosionFireEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 0.2;
   velocityVariance = 0.05;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 250;
   particles = "FuelExplosionFire";
};

datablock ParticleData(FuelExplosionSparks)
{
   textureName          = "~/data/shapes/splody/debris.dts";
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;
   colors[0]     = "0.60 0.40 0.30 1.0";
   colors[1]     = "0.60 0.40 0.30 0.8";
   colors[2]     = "1.0 0.40 0.30 0.0";
   sizes[0]      = 0.25;
   sizes[1]      = 0.15;
   sizes[2]      = 0.15;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(FuelExplosionSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "FuelExplosionSparks";
};

datablock ParticleData(FuelDebrisTrail)
{
   textureName          = "~/data/shapes/splody/debris.dts";
   dragCoefficient      = 1;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0;
   windCoefficient      = 0;
   constantAcceleration = 0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 100;
   spinSpeed     = 0;
   spinRandomMin = -90.0;
   spinRandomMax =  90.0;
   useInvAlpha   = true;
   colors[0]     = "0.8 0.8 0.8 0.2";
   colors[1]     = "0.8 0.8 0.8 0.2";
   colors[2]     = "0.8 0.8 0.8 0.2";
   sizes[0]      = 0.2;
   sizes[1]      = 0.3;
   sizes[2]      = 0.4;
   times[0]      = 0.1;
   times[1]      = 0.2;
   times[2]      = 0.3;
};

datablock ParticleEmitterData(FuelDebrisTrailEmitter)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 170;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   lifetimeMS       = 1000;
   particles = "FuelDebrisTrail";
};
datablock DebrisData(FuelExplosionDebris)
{
   shapeFile = "~/data/shapes/splody/debris.dts";
   emitters = "FuelDebrisTrailEmitter";
   elasticity = 0.3;
   friction = 0.7;
   numBounces = 3;
   bounceVariance = 1;
   explodeOnMaxBounce = false;
   staticOnMaxBounce = false;
   snapOnMaxBounce = false;
   minSpinSpeed = 0;
   maxSpinSpeed = 700;
   render2D = false;
   lifetime = 1;
   lifetimeVariance = 0.5;
   velocity = 100;
   velocityVariance = 60;
   fade = true;
   useRadiusMass = true;
   baseRadius = 0.25;
   gravModifier = 2.0;
   terminalVelocity = 100;
   ignoreWater = true;
};

datablock ExplosionData(FuelExplosion)
{
   soundProfile = FuelExplosionSound;
   lifeTimeMS = 1900;
   particleEmitter = FuelExplosionFireEmitter;
   particleDensity = 100;
   particleRadius = 5;
   emitter[0] = FuelExplosionSmokeEmitter;
   emitter[1] = FuelExplosionSparkEmitter;
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
   debris = FuelExplosionDebris;
   debrisThetaMin = 0;
   debrisThetaMax = 40;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisNum = 20;
   debrisNumVariance = 8;
   debrisVelocity = 4;
   debrisVelocityVariance =1;
   impulseRadius = 30;
   impulseForce = 25;
   lightStartRadius = 9;
   lightEndRadius = 4;
   lightStartColor = "0.5 0.5 0";
   lightEndColor = "0 0 0";
};
datablock StaticShapeData(BarrelA)
{
   category    = "targets";
   shapeFile    = "~/data/shapes/splody/barrel.dts";
   damageRadius     = 10;
   radiusDamage   = 50;
   damageType   = barrelAdebris;
   damageImpulse   = 200;
   maxDamage      = 30;
   chaosPoints	= 20;
   chaosCleared = false;
};

function BarrelA::Damage(%theDatablock,%aBarrel,%sourceObject,%pos,%damage,%damagetype)
{
  %aBarrel.applyDamage(%damage);
  if(%aBarrel.getDamageLevel() >= %theDatablock.maxDamage)
  {
    %theDatablock.Explode( %aBarrel ,%pos, %sourceObject);
  }
}


function BarrelA::Explode(%theDatablock, %aBarrel, %position, %sourceObject)
{
  if(%aBarrel.exploded)
		return;
  %aBarrel.exploded = true;
  
  //add chaos points==========
  %currentPoints = %sourceObject.client.player.getEnergyLevel() + %theDatablock.chaosPoints;
	%sourceObject.client.player.setEnergyLevel(%currentPoints);
	//============================
	
  %boom = new Explosion()
  {
    datablock = FuelExplosion;
    position  = %position;
    sourceObject  = %aBarrel.sourceObject;
    sourceSlot   = %aBarrel.sourceSlot;
    client   = %aBarrel.client;
  };
  MissionCleanup.add(%boom);
  radiusDamage(%aBarrel,%position,%theDatablock.damageRadius,
                       %theDatablock.radiusDamage,%source.damageType,%theDatablock.damageImpulse);
  %aBarrel.schedule(100, "delete");
}
